// <clown>csc.exe /debug+ /r:Gregor.Core.dll,Gregor.Editing.dll,Gregor.WinShell.dll ExportCodeTokens.cs</clown>
// <shell:csc.exe /debug+ /r:Gregor.Core.dll,Gregor.Editing.dll,Gregor.WinShell.dll $Vars.DocName%>
// <shell:$Vars.DocExePath%>

using System;
using System.Collections;
using System.Reflection;
using Gregor.Core;
using Gregor.Editing;

namespace Gregor {

public class ExportCodeTokens {

    public static void Main(string[] args) {

        if(args.Length < 1){
            W("Syntax:");
            W("    ExportCodeTokens <assembly-name> [<assembly-name-2>]+");
            Environment.Exit(1);
        }

        try{
            Run(args);
        }catch(Exception ex){
            W(ex);
        }
    }

    private static void Run(string[] args){
        CCodeTokenList list = new CCodeTokenList("Code");
        CAssemblyLoader loader = new CAssemblyLoader();
        loader.LocalAssemblyFolder = Environment.CurrentDirectory;
        foreach(string sAssembly in args){
            try{
               Assembly a = loader.LoadAssembly(sAssembly);
               if(a != null){
                    list.ParseAssembly(a);
               }             
            }catch(Exception ex){
                W(ex);
            }
        }
        foreach(string sToken in list){
            W(sToken);
        }
    }

    private static void W(object obj){
        Console.WriteLine(obj);
    }

} // class ExportCodeTokens

} // namespace Gregor
