Option Strict On

Imports System
Imports System.Collections
Imports System.IO
Imports System.Text

Namespace GetExt

Public Module MStart

Private m_Extensions As Hashtable

Public Sub Main(ByVal args() As String)
    Log("GetExt - Extension Finder")
    If args.Length <> 1 Then
        Log("Syntax:")
        Log("    GetExt <root-directory>")
        Exit Sub
    End If
    m_Extensions = New Hashtable(36)
    Log("Directory: " & args(0))
    Dim dir As New DirectoryInfo(args(0))
    ProcessDirectory(dir)
    Dim sb As New StringBuilder(1024)
    Log("Statistics:")
    Dim di As DictionaryEntry
    For Each di In m_Extensions
        Log("    " & di.Key.ToString() & " (" & di.Value.ToString() & "x)")
        sb.Append("*")
        sb.Append(di.Key.ToString())
        sb.Append(";")
    Next di
    Log("Patterns:")
    Log("    " & sb.ToString())
    Log("Count: " & m_Extensions.Count)
End Sub

Private Sub ProcessDirectory(ByVal dir As DirectoryInfo)
    ' get files
    Dim file As FileInfo, files() As FileInfo = dir.GetFiles()
    For Each file In files
        Dim sExt As String = file.Extension
        If sExt <> String.Empty Then
            AddToHashtable(sExt)
        End If
    Next File
    ' recurse
    Dim subDir As DirectoryInfo
    For Each subDir In dir.GetDirectories()
        ProcessDirectory(subDir)
    Next subDir
End Sub

Private Sub AddToHashtable(ByVal sExt As String)
    Dim count As Int32 = 0
    If m_Extensions.ContainsKey(sExt) Then
        count = DirectCast(m_Extensions(sExt), Int32)
    End If
    m_Extensions(sExt) = count + 1
End Sub

Private Sub Log(ByVal o As Object)
    Console.WriteLine(o)
End Sub

End Module

End Namespace
