// <shell:csc.exe /debug+ /r:Gregor.Core.dll,Gregor.NetConsole.dll $Vars.DocName%>
// <shell:$Vars.DocExePath%>

#define DEBUG

using System;
using Gregor.Core;
using Gregor.Core.Collections;
using Gregor.Core.Configuration;
using Gregor.NetConsole;
using Gregor.NetConsole.Engine;

namespace Gregor {

[Module()]
public class TextGen {

    public static void Main(string[] args) {
        Dev.TraceCallback = Dev.ConsoleTraceCallback;
        CCommandLine cmdLine = new CCommandLine(args);
        if(false == cmdLine.HasOptionWithAnyValue("/pathinfo", true)){
            Dev.Trace("Syntax:");
            Dev.Trace("    TextGen /pathinfo:<path-info-file>");
            Dev.Trace("Where:");
            Dev.Trace("    path-info-file ::= file name of XML file with path and template information");
            Dev.Trace("Example:");
            Dev.Trace("    TextGen /pathinfo:MyPathInfo.xml");
            Environment.Exit(1);
        }
        try{
            Run(cmdLine);
        }catch(Exception ex){
            Dev.ProcessException(ex);
        }
    }

    private static void Run(CCommandLine cmdLine){
        CTextGenerationInfo info = new CTextGenerationInfo(new object());
        string sPathInfoFile = cmdLine.GetOptionValue("/pathinfo");
        info.PathInfoDocument = FileUtil.ReadXmlFile(sPathInfoFile);
        info.InputDirectory = Environment.CurrentDirectory; // FileUtil.GetDirectory(sPathInfoFile);
        info.OutputDirectory = Environment.CurrentDirectory;
        info.Interpreter = new CCurlyInterpreter();
        CTextGenerator generator = new CTextGenerator();
        generator.Generate(info);
        Dev.Trace(info.FilesProduced.Count + " files generated.");
    }

} // module TextGen

} // namespace Gregor
