Option Strict On

Imports System
Imports System.IO

Namespace Untouch

Public Module M

    Public Sub Main(ByVal args() As String)
        ' hello
        W("Untouch - resets file timestamps")
        ' args
        If args.Length <> 2 Then
            W("Syntax:")
            W("    Untouch <reference-dir> <file>")
            Environment.Exit(1)
        End If
        ' so
        Dim di As New DirectoryInfo(args(0))
        Dim stamp As DateTime = DateTime.MinValue
        ' get
        ProcessDirectory(di, stamp)
        ' set
        Dim fi As New FileInfo(args(1))
        If fi.LastWriteTime > stamp OrElse fi.CreationTime > stamp Then
            fi.LastAccessTime = stamp
            fi.LastWriteTime = stamp
            fi.CreationTime = stamp
            fi.Refresh()
            W("Reset  '" & args(1) & "' to '" & stamp & "'.'")
        End If
    End Sub

    Private Sub ProcessDirectory(ByVal di As DirectoryInfo, ByRef stamp As DateTime)
        ' compare files
        Dim fi As FileInfo
        For Each fi In di.GetFiles()
            If fi.LastWriteTime > stamp OrElse fi.CreationTime > stamp Then
                If fi.LastWriteTime > fi.CreationTime Then
                    stamp = fi.LastWriteTime
                Else
                    stamp = fi.CreationTime
                End If
            End If
        Next fi
        ' kids
        Dim diSub As DirectoryInfo
        For Each diSub in di.GetDirectories()
            ProcessDirectory(diSub, stamp)
        Next diSub
    End Sub

    Private Sub W(ByVal obj As Object)
        Console.WriteLine(obj)
    End Sub

End Module ' M

End Namespace ' Untouch