// <action:OutputWindow>
// <shell:csc.exe /t:winexe $Vars.DocName%>
// <start:$Vars.DocExePath%>

using System;
using System.Collections;
using System.Text;
using System.Diagnostics;
using System.Drawing; 
using System.Windows.Forms;
using System.Runtime.InteropServices;

public class C {

    internal delegate bool EnumWindowsCallback(IntPtr hWnd, IntPtr lParam);

    [DllImport("user32")]
    extern static internal int EnumWindows(EnumWindowsCallback callback, IntPtr lParam);

    [DllImport("user32")]
    extern static internal bool IsWindowVisible(IntPtr hWnd);

    [DllImport("user32")]
    extern static internal bool MoveWindow(IntPtr hWnd, int X, int Y, int nWidth, int nHeight, bool bRepaint);

    public static void Main(string[] args){

        F frm = new F();
        Application.Run(frm);
    }

} // class C

internal class F : Form {

    private TextBox m_XBox;
    private TextBox m_YBox;
    private TextBox m_WidthBox;
    private TextBox m_HeightBox;
    private Button m_ApplyButton;
    private ArrayList m_Handles;

    public F(){
        this.Text = "Position Windows";
        this.ShowInTaskbar = false;
        this.MinimizeBox = this.MaximizeBox = false;
        this.TopLevel = this.TopMost = true;
        this.FormBorderStyle = FormBorderStyle.FixedDialog;
        this.Size = new Size(220, 100);
        this.AddTextBox(ref m_XBox,       5,  5, 50, 22,  100);
        this.AddTextBox(ref m_YBox,      60,  5, 50, 22,   80);
        this.AddTextBox(ref m_WidthBox,   5, 35, 50, 22, 1500);
        this.AddTextBox(ref m_HeightBox, 60, 35, 50, 22,  900);
        m_ApplyButton = new Button();
        m_ApplyButton.Text = "Apply";
        m_ApplyButton.Bounds = new Rectangle(120, 15, 80, 25);
        m_ApplyButton.Enabled = true;
        m_ApplyButton.Click += new EventHandler(this.HandleApplyButtonClick);
        this.Controls.Add(m_ApplyButton);
        this.AcceptButton = m_ApplyButton;
        m_Handles = new ArrayList();
    }

    private void AddTextBox(ref TextBox txt, int left, int top, int width, int height, int value){
        txt = new TextBox();
        txt.Location = new Point(left, top);
        txt.Size = new Size(width, height);
        txt.Text = value.ToString();
        this.Controls.Add(txt);
    }

    private void HandleApplyButtonClick(object sender, EventArgs e){
        try{
            int x = Convert.ToInt32(m_XBox.Text);
            int y = Convert.ToInt32(m_YBox.Text);
            int width = Convert.ToInt32(m_WidthBox.Text);
            int height = Convert.ToInt32(m_HeightBox.Text);
            foreach(IntPtr hWnd in m_Handles){
                C.MoveWindow(hWnd, x, y, width, height, true);
            }
        }catch(Exception ex){
            MessageBox.Show(ex.ToString());
        }
    }

    protected override void OnLoad(EventArgs e){
        try{
            C.EnumWindows(
                delegate(IntPtr hWnd, IntPtr lParam){
                    if(C.IsWindowVisible(hWnd)){
                        m_Handles.Add(hWnd);
                    }
                    return true;
                },
                IntPtr.Zero
            );
        }catch(Exception ex){
            MessageBox.Show(ex.ToString());
        }finally{
            base.OnLoad(e);
        }
    }

} // class F
